import {createApp} from 'vue'
import App from './App'
import { createRouter, createWebHistory } from "vue-router"

import Profile from './components/Profile'
import Post from './components/Post'
import Comment from './components/Comment'
import Login from './components/Login'

const routes = [
    {
        path: '/profiles',
        component: Profile
    },
    {
        path: '/posts/:profileId',
        name: 'posts',
        component: Post,
        props: true
    },
    {
        path: '/',
        name: 'comments',
        component: Comment
    },
    {
        path: '/login',
        name: 'login',
        component: Login
    }
]

const router = createRouter({
    routes, 
    history: createWebHistory()
})


createApp(App).use(router).mount('#app')