package com.webproglabs.lab1.lab34.controller;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.webproglabs.lab1.lab34.model.Comment;
import com.webproglabs.lab1.lab34.model.Post;
import com.webproglabs.lab1.lab34.model.Profile;

import java.util.ArrayList;
import java.util.List;

public class PostDto {
    private Long id;
    private String text;
    private List<CommentDto> comments = new ArrayList<>();

    private String authorLogin;

    public PostDto(Post post){
        this.id = post.getId();
        this.text = post.getText();
        for(Comment comment: post.getComments()){
            comments.add(new CommentDto(comment));
        }
        this.authorLogin = post.getAuthor().getLogin();
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public long getId() {
        return id;
    }
    public String getText() {return text;}
    public List<CommentDto> getComments() {return comments;}
    public String getAuthor() {return authorLogin;}
}
