package com.webproglabs.lab1.lab34.controller;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.webproglabs.lab1.lab34.model.Comment;
import com.webproglabs.lab1.lab34.model.Post;
import com.webproglabs.lab1.lab34.model.Profile;
import com.webproglabs.lab1.lab34.model.UserRole;

import java.util.ArrayList;
import java.util.List;

public class ProfileDto {
    private Long id;
    private String login;
    private String password;
    private List<CommentDto> comments = new ArrayList<>();

    private List<PostDto> posts = new ArrayList<>();

    private UserRole role;

    public ProfileDto(){}

    public ProfileDto(Profile profile){
        this.id = profile.getId();
        this.login = profile.getLogin();
        this.password = profile.getPassword();
        this.role = profile.getRole();
        for(Comment comment: profile.getComments()){
            comments.add(new CommentDto(comment));
        }
        for (Post post: profile.getPosts()) {
            posts.add(new PostDto(post));
        }
    }

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public long getId() {
        return id;
    }
    public String getLogin() {return login;}
    public void setLogin(String login) {this.login = login;}
    public String getPassword() {return password;}

    public UserRole getRole() {return role;}

    public void setPassword(String password) {this.password = password;}
    public List<CommentDto> getComments() {return comments;}
    public List<PostDto> getPosts() {return posts;}
}
